var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var BillingAddressBladeViewModel = (function (_super) {
        __extends(BillingAddressBladeViewModel, _super);
        function BillingAddressBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.location = ko.observable();
            this.title = ko.observable("Contact Info");
            this.icon = ko.observable(MsPortalFx.Base.Images.Person());
            this._container = container;
            this._dataContext = dataContext;
            this._initializeFormFields(container, initialState);
            this._setupCommandBar();
        }
        BillingAddressBladeViewModel.prototype._initializeFormFields = function (container, initialState) {
            var addressLine1Options = {
                label: ko.observable("Address Line 1"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Address Line 1"),
                readonly: true
            };
            var addressLine1TxField = new FxForms.TextBox.ViewModel(container, addressLine1Options);
            addressLine1TxField.value("501 141st AVE");
            var addressLine2Options = {
                label: ko.observable("Address Line 2"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Address Line 2"),
                readonly: true
            };
            var addressLine2TxField = new FxForms.TextBox.ViewModel(container, addressLine2Options);
            addressLine2TxField.value("Kris");
            var cityOptions = {
                label: ko.observable("City"),
                validations: ko.observableArray([]),
                emptyValueText: ko.observable("City"),
                readonly: true
            };
            var cityTxField = new FxForms.TextBox.ViewModel(container, cityOptions);
            cityTxField.value("Bellevue");
            var stateOptions = {
                label: ko.observable("State"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("State"),
                readonly: true
            };
            var stateTxField = new FxForms.TextBox.ViewModel(container, stateOptions);
            stateTxField.value("WA");
            var zipCodeOptions = {
                label: ko.observable("Company"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Company"),
                readonly: true
            };
            var zipCodeTxField = new FxForms.TextBox.ViewModel(container, zipCodeOptions);
            zipCodeTxField.value("98007");
            var sectionOptions = {
                children: ko.observableArray([
                    addressLine1TxField,
                    addressLine2TxField,
                    cityTxField,
                    stateTxField,
                    zipCodeTxField
                ])
            };
            this.generalSection = new FxForms.Section.ViewModel(container, sectionOptions);
        };
        BillingAddressBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([]);
        };
        BillingAddressBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var args = {};
            return Q();
        };
        return BillingAddressBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.BillingAddressBladeViewModel = BillingAddressBladeViewModel;
});
