var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../Shared/Resources"], function (require, exports, Resources) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    var InvoiceDetailBladeViewModel = (function (_super) {
        __extends(InvoiceDetailBladeViewModel, _super);
        function InvoiceDetailBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.invoiceId = ko.observable();
            this.location = ko.observable("local");
            this.invoiceData = ko.observable();
            this.invoices = ko.observable();
            this.title("Invoice");
            this._container = container;
            this._dataContext = dataContext;
            ko.reactor(container, function () {
                if (_this.invoices()) {
                    var x = _this.invoices();
                    MsPortalFx.extend(x, {
                        Logo1Image: ko.observable(Resources.Icon.InvoiceLogo1Image),
                    });
                    _this.invoiceData(x);
                    _this.title("Invoice ({0})".format(x.BillingPeriodString));
                    _this.subtitle(x.SubscriptionId.toString());
                }
            });
            this._setupCommandBar();
        }
        InvoiceDetailBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([]);
        };
        InvoiceDetailBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionId(inputs.subscriptionId);
            this.invoiceId(inputs.invoiceId);
            var subscriptionIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            var q = this._dataContext.sharedContext.invoicesManager.getInvoicesForSubscription(inputs.subscriptionId, subscriptionIds, inputs.invoiceId)
                .then(function (result) {
                _this.invoices(result);
            });
            return q;
        };
        InvoiceDetailBladeViewModel.prototype._getBillingPeriod = function (invoice) {
            var st = new Date(invoice.InvoiceStartTime());
            var et = new Date(invoice.InvoiceEndTime());
            var startTimeString = this._getUtcDateString(st);
            var endTimeString = this._getUtcDateString(et);
            var period = "{0}-{1}".format(startTimeString, endTimeString);
            return period;
        };
        InvoiceDetailBladeViewModel.prototype._getUtcDate = function (date) {
            var dateUtc = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
            return dateUtc;
        };
        InvoiceDetailBladeViewModel.prototype._getUtcDateString = function (date) {
            return "{0}/{1}/{2}".format(date.getUTCMonth() + 1, date.getUTCDate(), date.getUTCFullYear());
        };
        return InvoiceDetailBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.InvoiceDetailBladeViewModel = InvoiceDetailBladeViewModel;
});
