define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var SelectBillingPeriodPartViewModel = (function () {
        function SelectBillingPeriodPartViewModel(container, initialState, dataContext) {
            var _this = this;
            this._view = ko.observableArray([]);
            this._container = container;
            this._dataContext = dataContext;
            var billingPeriodDropDownOptions = {
                label: ko.observable("Billing Period"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the Billing Period to list Subscription Summary"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.billingPeriodsDropDown = new FxDropDown.ViewModel(container, billingPeriodDropDownOptions);
            this.billingPeriodsDropDown.value.subscribe(container, function (newPeriod) {
                _this._dataContext.selectedBillingPeriod(newPeriod);
            });
            this.formSection = new FxForms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([
                    this.billingPeriodsDropDown
                ])
            });
        }
        SelectBillingPeriodPartViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            var subIds = this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList;
            if (subIds.length === 0)
                return Q();
            return this._dataContext.sharedContext.billingOverviewManager.getBillingPeriods(subIds).then(function (billingPeriods) {
                var billingPeriodDropdownValues = billingPeriods.map(function (bp) {
                    return {
                        text: ko.observable(bp.Label),
                        value: bp,
                        disabled: ko.observable(false),
                    };
                });
                billingPeriodDropdownValues.push({
                    text: ko.observable("Please select a Billing Period"),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.billingPeriodsDropDown.options(billingPeriodDropdownValues);
                var currentBP = billingPeriods.first(function (bp) { return bp.IsCurrent; });
                _this.billingPeriodsDropDown.value(currentBP);
                _this.billingPeriodsDropDown.disabled(false);
            });
        };
        return SelectBillingPeriodPartViewModel;
    }());
    exports.SelectBillingPeriodPartViewModel = SelectBillingPeriodPartViewModel;
});
