var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    var FxForms = MsPortalFx.ViewModels.Forms;
    var DatePicker = FxForms.DatePicker;
    var Chart = MsPortalFx.ViewModels.Controls.Visualization.Chart;
    var SimpleChart = MsPortalFx.ViewModels.Controls.Visualization.SimpleChart;
    var FxControls = MsPortalFx.ViewModels.Controls;
    "use strict";
    var UsageAndQuotaTrendBladeViewModel = (function (_super) {
        __extends(UsageAndQuotaTrendBladeViewModel, _super);
        function UsageAndQuotaTrendBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.selectedProvider = ko.observable();
            this.selectedResource = ko.observable();
            this.selectedSubscriptionId = ko.observable();
            this.allProviderList = ko.observableArray([]);
            this.allResourceList = ko.observableArray([]);
            this.location = ko.observable("local");
            this.subscriptionIdIn = ko.observable();
            this.subscriptionIdList = ko.observableArray([]);
            this.title("Trend Report");
            this._container = container;
            this._dataContext = dataContext;
            this._initFiltersAndButtonsSection(container);
            this.simpleChartVM = new MsPortalFx.ViewModels.Controls.Visualization.SimpleChart.ViewModel(container, {
                series: ko.observableArray([]),
                chartType: ko.observable(0),
                xAxis: {},
                yAxis: {
                    max: ko.observable(100),
                    min: ko.observable(0),
                    unit: ko.observable(MsPortalFx.UnitConversion.Unit.Percentage)
                },
                legendPosition: 3
            });
        }
        UsageAndQuotaTrendBladeViewModel.prototype._initFiltersAndButtonsSection = function (container) {
            var _this = this;
            var subscriptionsDropDownOptions = {
                label: ko.observable("Subscription"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a Subscription"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.subscriptionsDropDown = new FxDropDown.ViewModel(container, subscriptionsDropDownOptions);
            this.subscriptionsDropDown.value.subscribe(container, function (newSubscriptionId) {
                _this.selectedSubscriptionId(newSubscriptionId);
            });
            var providerDropDownOptions = {
                label: ko.observable("Quota Provider"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose a Provider"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.providersDropDown = new FxDropDown.ViewModel(container, providerDropDownOptions);
            this.providersDropDown.value.subscribe(container, function (resource) {
                _this.selectedProvider(resource);
            });
            var fromDatePicker = {
                label: ko.observable("From"),
                infoBalloonContent: ko.observable("Choose a start date"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left)
            };
            this.fromDatePicker = new DatePicker.ViewModel(this._container, fromDatePicker);
            var toDatePicker = {
                label: ko.observable("To"),
                infoBalloonContent: ko.observable("Choose an end date"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left)
            };
            this.toDatePicker = new DatePicker.ViewModel(this._container, toDatePicker);
            var quotaDropdown = {};
            var quotaResourceDropDownOptions = {
                label: ko.observable("Quota Resource"),
                labelPosition: ko.observable(FxForms.LabelPosition.Left),
                infoBalloonContent: ko.observable("Choose the Resource"),
                options: ko.observableArray([{ text: ko.observable("Loading.."), value: "" }])
            };
            this.resourcesDropDown = new FxDropDown.ViewModel(container, quotaResourceDropDownOptions);
            this.resourcesDropDown.value.subscribe(container, function (resource) {
                _this.selectedResource(resource);
            });
            this.applyFiltersButton = new FxControls.SimpleButton.ViewModel(container, {
                onClick: this._onApplyButtonClicked.bind(this),
                text: "Apply",
                primary: true,
            });
            var column1 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.fromDatePicker,
                    this.subscriptionsDropDown,
                    this.resourcesDropDown
                ])
            });
            var column2 = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(0),
                children: ko.observableArray([
                    this.toDatePicker,
                    this.providersDropDown,
                ])
            });
            this.filtersSection = new MsPortalFx.ViewModels.Forms.Section.ViewModel(container, {
                style: ko.observable(3),
                children: ko.observableArray([
                    column1, column2
                ])
            });
        };
        UsageAndQuotaTrendBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var _this = this;
            this.subscriptionIdList(this._dataContext.sharedContext.subscriptionsManager.subscriptionIdList);
            this.subscriptionIdIn(this.subscriptionIdList().first());
            var q1 = this._dataContext.sharedContext.usageAndQuotaDataManager.getAzSQuotaFilters(this.subscriptionIdIn(), this.subscriptionIdList()).then(function (filters) {
                var resourceList = [];
                var providers = Object.keys(filters.Resources);
                _this.allProviderList(providers);
                var providerDropdownValues = providers.map(function (mr) {
                    return {
                        text: ko.observable(mr),
                        value: mr,
                        disabled: ko.observable(false)
                    };
                });
                providerDropdownValues.unshift({
                    text: ko.observable("Please select a provider..."),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.providersDropDown.options(providerDropdownValues);
                _this.providersDropDown.value(_this.allProviderList().first());
                _this.providersDropDown.disabled(false);
                Object.keys(filters.Resources).forEach(function (key) {
                    resourceList = resourceList.concat(filters.Resources[key]);
                });
                _this.allResourceList(resourceList);
                var resourcesDropdownValues = resourceList.map(function (mr) {
                    return {
                        text: ko.observable(mr),
                        value: mr,
                        disabled: ko.observable(false)
                    };
                });
                resourcesDropdownValues.unshift({
                    text: ko.observable("All Quota Resources"),
                    value: "-1",
                    disabled: ko.observable(false)
                });
                _this.resourcesDropDown.options(resourcesDropdownValues);
                _this.resourcesDropDown.value("-1");
                _this.resourcesDropDown.disabled(false);
                filters.BillingCyclePeriods.forEach(function (period) {
                    if (period.IsCurrent) {
                        var date = new Date(period.StartDate);
                        var startDate = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate());
                        _this.fromDatePicker.value(startDate);
                        date = new Date(period.EndDate);
                        var endDate = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate());
                        _this.toDatePicker.value(endDate);
                    }
                });
                _this.providersDropDown.value(providers[0]);
            });
            var q2 = this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                var dropdownValues = subscriptions.map(function (s) {
                    return {
                        text: ko.observable(s.uniqueDisplayName),
                        value: s.subscriptionId,
                        disabled: ko.observable(false)
                    };
                });
                dropdownValues.unshift({
                    text: ko.observable("Please select a subscription..."),
                    value: null,
                    disabled: ko.observable(false)
                });
                _this.subscriptionsDropDown.options(dropdownValues);
                if (_this.subscriptionIdIn()) {
                    _this.subscriptionsDropDown.value(_this.subscriptionIdIn());
                }
                else {
                    _this.subscriptionsDropDown.value(null);
                }
            });
            return Q.all([q1, q2]).then(function () {
                _this._onApplyButtonClicked();
            });
        };
        UsageAndQuotaTrendBladeViewModel.prototype._onApplyButtonClicked = function () {
            var _this = this;
            var subId = this.selectedSubscriptionId();
            var provider;
            var resource = [];
            var subIdList = [];
            if (this.selectedProvider() == "-1") {
                provider = this.allProviderList().first();
            }
            else {
                provider = this.selectedProvider();
            }
            if (this.selectedResource() == "-1") {
                resource = this.allResourceList();
            }
            else {
                resource.push(this.selectedResource());
            }
            subIdList.push(subId);
            var input = {
                SubscriptionIdList: subIdList,
                QuotaProvider: provider,
                QuotaResourceNames: resource,
                StartTime: this.fromDatePicker.value(),
                EndTime: this.toDatePicker.value(),
            };
            this._dataContext.sharedContext.usageAndQuotaDataManager.getAzsTrendView(subId, input).then(function (quotaRecords) {
                var quota = ko.observableArray(quotaRecords);
                quota.mapInto(_this._container, function (seriesLifetime, dataSeries) {
                    var chartSeries = new SimpleChart.Series();
                    chartSeries.name = dataSeries.QuotaResourceName;
                    chartSeries.viewOptions = {
                        displayName: ko.observable(dataSeries.QuotaResourceName),
                    };
                    var data = ko.observableArray(dataSeries.AzureStackQuotaTrendData);
                    data.mapInto(_this._container, function (seriesLifetime, dataPoint) {
                        var date = new Date(dataPoint.DateTime);
                        return new Chart.ChartItem(date, dataPoint.ConsumptionPercentage);
                    }, chartSeries.values);
                    return chartSeries;
                }, _this.simpleChartVM.series);
            });
        };
        return UsageAndQuotaTrendBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UsageAndQuotaTrendBladeViewModel = UsageAndQuotaTrendBladeViewModel;
});
