var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var UserBasicProfileBladeViewModel = (function (_super) {
        __extends(UserBasicProfileBladeViewModel, _super);
        function UserBasicProfileBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.location = ko.observable();
            this._userProfileModel = ko.observable();
            this._isReadMode = ko.observable(true);
            this.title = ko.observable("Contact Info");
            this.icon = ko.observable(MsPortalFx.Base.Images.Person());
            this._container = container;
            this._dataContext = dataContext;
            this._initDataModel();
            this._initializeContactInfoSectionFormFields(container, this._userProfileModel(), initialState);
            this._initializeBillingAddressFormFields(container, this._userProfileModel(), initialState);
            this._setupCommandBar();
        }
        UserBasicProfileBladeViewModel.prototype._initDataModel = function () {
            var x = {};
            x.BillingFirstName = ko.observable("Jagan");
            x.BillingLastName = ko.observable("Kris");
            x.BillingEmailAddress = ko.observable("jagan@cloudassert.com");
            x.BillingCompany = ko.observable("Cloud Assert");
            x.BillingAddress1 = ko.observable("501 141st AVE SE");
            x.BillingAddress2 = ko.observable("");
            x.BillingCity = ko.observable("Bellevue");
            x.BillingState = ko.observable("WA");
            x.BillingPostalCode = ko.observable("98007");
            x.BillingPhoneNumber = ko.observable("4256289105");
            this._userProfileModel(x);
        };
        UserBasicProfileBladeViewModel.prototype._initializeContactInfoSectionFormFields = function (container, dataModel, initialState) {
            var firstNameOptions = {
                label: ko.observable("First Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("First Name"),
                readonly: this._isReadMode
            };
            var firstNameTxField = new FxForms.TextBox.ViewModel(container, firstNameOptions);
            firstNameTxField.value = dataModel.BillingFirstName;
            var lastNameOptions = {
                label: ko.observable("Last Name"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\-]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Last Name"),
                readonly: this._isReadMode
            };
            var lastNameTxField = new FxForms.TextBox.ViewModel(container, lastNameOptions);
            lastNameTxField.value = dataModel.BillingLastName;
            var emailOptions = {
                label: ko.observable("Contact Email"),
                validations: ko.observableArray([]),
                emptyValueText: ko.observable("Contact Email"),
                readonly: this._isReadMode
            };
            var emailTxField = new FxForms.TextBox.ViewModel(container, emailOptions);
            emailTxField.value = dataModel.BillingEmailAddress;
            var phoneOptions = {
                label: ko.observable("Phone Number"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Phone Number"),
                readonly: this._isReadMode
            };
            var phoneNumberTxField = new FxForms.TextBox.ViewModel(container, phoneOptions);
            phoneNumberTxField.value = dataModel.BillingPhoneNumber;
            var companyOptions = {
                label: ko.observable("Company"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Company"),
                readonly: this._isReadMode
            };
            var companyTxField = new FxForms.TextBox.ViewModel(container, companyOptions);
            companyTxField.value = dataModel.BillingCompany;
            var sectionOptions = {
                children: ko.observableArray([
                    firstNameTxField,
                    lastNameTxField,
                    emailTxField,
                    phoneNumberTxField,
                    companyTxField
                ])
            };
            this.contactInfoSection = new FxForms.Section.ViewModel(container, sectionOptions);
        };
        UserBasicProfileBladeViewModel.prototype._initializeBillingAddressFormFields = function (container, dataModel, initialState) {
            var addressLine1Options = {
                label: ko.observable("Address Line 1"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Address Line 1"),
                readonly: this._isReadMode
            };
            var addressLine1TxField = new FxForms.TextBox.ViewModel(container, addressLine1Options);
            addressLine1TxField.value = dataModel.BillingAddress1;
            var addressLine2Options = {
                label: ko.observable("Address Line 2"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[a-zA-Z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Address Line 2"),
                readonly: this._isReadMode
            };
            var addressLine2TxField = new FxForms.TextBox.ViewModel(container, addressLine2Options);
            addressLine2TxField.value = dataModel.BillingAddress2;
            var cityOptions = {
                label: ko.observable("City"),
                validations: ko.observableArray([]),
                emptyValueText: ko.observable("City"),
                readonly: this._isReadMode
            };
            var cityTxField = new FxForms.TextBox.ViewModel(container, cityOptions);
            cityTxField.value = dataModel.BillingCity;
            var stateOptions = {
                label: ko.observable("State"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("State"),
                readonly: this._isReadMode
            };
            var stateTxField = new FxForms.TextBox.ViewModel(container, stateOptions);
            stateTxField.value = dataModel.BillingState;
            var zipCodeOptions = {
                label: ko.observable("Company"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[A-Za-z0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Company"),
                readonly: this._isReadMode
            };
            var zipCodeTxField = new FxForms.TextBox.ViewModel(container, zipCodeOptions);
            zipCodeTxField.value = dataModel.BillingPostalCode;
            var countryOptions = {
                label: ko.observable("Country"),
                validations: ko.observableArray([
                    new MsPortalFx.ViewModels.RegExMatchValidation(/^[0-9\+]+[0-9\- ]+$/.source, "Invalid"),
                ]),
                emptyValueText: ko.observable("Country"),
                readonly: this._isReadMode
            };
            var countryTxField = new FxForms.TextBox.ViewModel(container, stateOptions);
            var sectionOptions = {
                children: ko.observableArray([
                    addressLine1TxField,
                    addressLine2TxField,
                    cityTxField,
                    stateTxField,
                    zipCodeTxField,
                ])
            };
            this.billingAddressSection = new FxForms.Section.ViewModel(container, sectionOptions);
        };
        UserBasicProfileBladeViewModel.prototype._setupCommandBar = function () {
            var _this = this;
            var editButton = new MsPortalFx.ViewModels.Toolbars.ToggleButton();
            editButton.label("Edit");
            editButton.icon(MsPortalFx.Base.Images.Edit());
            editButton.checked.subscribe(this._container, function (isChecked) {
                _this._isReadMode(!isChecked);
            });
            this.editButton = editButton;
            var saveButton = new MsPortalFx.ViewModels.Toolbars.CommandButton();
            saveButton.label("Save");
            saveButton.icon(MsPortalFx.Base.Images.Save());
            saveButton.command = {
                canExecute: ko.computed(this._container, function () { return !_this._isReadMode(); }),
                execute: function () {
                    _this.editButton.checked(false);
                    return Q();
                }
            };
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this.commandBar.setItems([editButton, saveButton]);
        };
        UserBasicProfileBladeViewModel.prototype.onInputsSet = function (inputs, settings) {
            var args = {};
            return Q();
        };
        return UserBasicProfileBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.UserBasicProfileBladeViewModel = UserBasicProfileBladeViewModel;
});
