define(["require", "exports"], function (require, exports) {
    "use strict";
    var UserBillingHistoryChartPartViewModel = (function () {
        function UserBillingHistoryChartPartViewModel(container, initialState, dataContext) {
            this._userInvoiceList = ko.observableArray([]);
            this._container = container;
            this._dataContext = dataContext;
            container.partTitle("Billing history");
            this.barChartVM = new MsPortalFx.ViewModels.Controls.Visualization.Chart.ViewModel(container);
            var view = new MsPortalFx.ViewModels.Controls.Visualization.Chart.BarChartView(1);
            this.barChartVM.views([view]);
            this.barChartVM.yAxis.showGridLines(true);
            this.barChartVM.legendPosition(0);
            var invoiceAmountSeries = new MsPortalFx.ViewModels.Controls.Visualization.Chart.Series();
            invoiceAmountSeries.name("Amount");
            this._userInvoiceList.mapInto(container, function (itemLifetime, invoice) {
                return {
                    xValue: "{0} '{1}".format(invoice.Month, invoice.Year),
                    yValue: invoice.TotalAmount
                };
            }, invoiceAmountSeries.values);
            this.barChartVM.series([invoiceAmountSeries]);
        }
        UserBillingHistoryChartPartViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            var q = this._dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                if (subscriptions.length === 0)
                    return Q();
                return _this._dataContext.sharedContext.invoicesManager.getInvoicingHistoryForUser(subscriptions.first().subscriptionId).then(function (list) {
                    _this._userInvoiceList(list);
                });
            });
            return q;
        };
        return UserBillingHistoryChartPartViewModel;
    }());
    exports.UserBillingHistoryChartPartViewModel = UserBillingHistoryChartPartViewModel;
});
