var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports", "../../_generated/BladeReferences"], function (require, exports, BladeReferences) {
    "use strict";
    var FxToolbars = MsPortalFx.ViewModels.Toolbars;
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var ArmHelpers = Common.Helpers;
    var AvailableCloudServiceLicensesBladeViewModel = (function (_super) {
        __extends(AvailableCloudServiceLicensesBladeViewModel, _super);
        function AvailableCloudServiceLicensesBladeViewModel(container, initialState, dataContext) {
            _super.call(this);
            this.subscriptionId = ko.observable();
            this.cspCustomerId = ko.observable();
            this.cspCustomerUserId = ko.observable();
            this.assignedLicenses = new Array();
            this.availableLicenses = new Array();
            this.location = ko.observable("local");
            this.title("License Details");
            this._container = container;
            this._dataContext = dataContext;
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                }
            };
            this.assignedLicensesGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "Id",
                    name: ko.observable("Offer Id"),
                },
                {
                    itemKey: "Name",
                    name: ko.observable("Name"),
                },
            ];
            this.assignedLicensesGrid.columns = ko.observableArray(basicColumns);
            this.assignedLicensesGrid.showHeader = true;
            this.assignedLicensesGrid.summary = ko.observable("Summary");
            this.assignedLicensesGrid.noRowsMessage("No items found");
            this.assignedLicensesGrid.selectableData.selectedItems.subscribe(container, function (selectedItems) {
                if (!selectedItems || selectedItems.length === 0) {
                    return;
                }
            });
            this._setupCommandBar();
        }
        AvailableCloudServiceLicensesBladeViewModel.prototype._setupCommandBar = function () {
            this.commandBar = new MsPortalFx.ViewModels.Toolbars.Toolbar(this._container);
            this._assignLicenseButton = this._createAssignLicenseButton();
            this._refreshButton = this._createRefreshButton();
            this.commandBar.setItems([this._assignLicenseButton, this._refreshButton]);
        };
        AvailableCloudServiceLicensesBladeViewModel.prototype._createAssignLicenseButton = function () {
            var _this = this;
            var addButton = new FxToolbars.CommandButton({
                label: "Assign",
                icon: MsPortalFx.Base.Images.Add(),
                command: {
                    execute: function () {
                        return _this._container.openBlade(new BladeReferences.AssignCloudServiceLicensesBladeReference({
                            subscriptionId: _this.subscriptionId(),
                            cspCustomerId: _this.cspCustomerId(),
                            cspCustomerUserId: _this.cspCustomerUserId(),
                            availableLicenses: _this.availableLicenses,
                        }));
                    },
                    canExecute: ko.computed(this._container, function () {
                        return true;
                    }),
                }
            });
            return addButton;
        };
        AvailableCloudServiceLicensesBladeViewModel.prototype._createRefreshButton = function () {
            var _this = this;
            var refreshButton = new FxToolbars.CommandButton({
                label: "Refresh",
                icon: MsPortalFx.Base.Images.Refresh(),
                command: {
                    canExecute: ko.observable(true),
                    execute: function (result) {
                        _this.assignedLicensesGrid.loading(true);
                        return _this._dataContext.cspDataManager.getCspCustomerUserLicensesDetails(_this.subscriptionId(), _this.cspCustomerId(), _this.cspCustomerUserId())
                            .then(function (licenseInfo) {
                            if (licenseInfo != null) {
                                _this.assignedLicenses = licenseInfo.AssignedLicenses;
                                _this.availableLicenses = licenseInfo.AvailableLicenses;
                                _this.assignedLicensesGrid.items(licenseInfo.AssignedLicenses);
                                _this.assignedLicensesGrid.loading(false);
                            }
                        });
                    }
                }
            });
            return refreshButton;
        };
        AvailableCloudServiceLicensesBladeViewModel.prototype.onInputsSet = function (inputs) {
            var _this = this;
            this.subscriptionId(inputs.subscriptionId);
            this.cspCustomerId(inputs.cspCustomerId);
            this.cspCustomerUserId(inputs.cspCustomerUserId);
            var args = {
                subscriptionId: this.subscriptionId(),
                location: this.location(),
                customerUserId: this.cspCustomerUserId(),
                customerTenantId: this.cspCustomerId(),
            };
            this.assignedLicensesGrid.loading(true);
            return this._dataContext.cspDataManager.getCspCustomerUserLicensesDetails(this.subscriptionId(), this.cspCustomerId(), this.cspCustomerUserId())
                .then(function (licenseInfo) {
                if (licenseInfo != null) {
                    _this.assignedLicenses = licenseInfo.AssignedLicenses;
                    _this.availableLicenses = licenseInfo.AvailableLicenses;
                    _this.assignedLicensesGrid.items(licenseInfo.AssignedLicenses);
                    _this.assignedLicensesGrid.loading(false);
                }
            });
        };
        return AvailableCloudServiceLicensesBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.AvailableCloudServiceLicensesBladeViewModel = AvailableCloudServiceLicensesBladeViewModel;
});
