var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var CloudServiceOffersListViewChildBladeViewModel = (function (_super) {
        __extends(CloudServiceOffersListViewChildBladeViewModel, _super);
        function CloudServiceOffersListViewChildBladeViewModel(container, initialState, dataContext) {
            var _this = this;
            _super.call(this);
            this.selectedOffer = ko.observable();
            this.id = ko.observable();
            this.name = ko.observable();
            this.descriptionText = ko.observable();
            this.descriptionUrl = ko.observable();
            this.subscriptionId = ko.observable();
            this.selectedCustomerId = ko.observable();
            this._initializeFormFields(container);
            this.actionBar = new MsPortalFx.ViewModels.ActionBars.GenericActionBar.ViewModel(container);
            this.actionBar.actionButtonLabel("Purchase");
            this.actionBar.actionButtonClick = function () {
                _this.actionBar.disabled(true);
                dataContext.sharedContext.subscriptionsManager.subscriptionsPromise.then(function (subscriptions) {
                    if (subscriptions.length > 0)
                        var subIds = subscriptions.map(function (s) { return s.subscriptionId; });
                    dataContext.cspDataManager.getCspEnabledSubIds(subIds).then(function (subscriptionsIds) {
                        var promise = dataContext.cspDataManager.purchaseCloudServiceLicense(_this.subscriptionId(), _this.selectedOffer(), _this.licenseQuantityTxField.value(), subscriptionsIds);
                        container.operations.add(promise);
                        promise.finally(function () {
                            container.closeCurrentBlade();
                        });
                    });
                });
            };
        }
        CloudServiceOffersListViewChildBladeViewModel.prototype._initializeFormFields = function (container, initialState) {
            var licensesOptions = {
                label: ko.observable("License Quantity"),
                emptyValueText: ko.observable(""),
            };
            this.licenseQuantityTxField = new FxForms.NumericTextBox.ViewModel(container, licensesOptions);
        };
        CloudServiceOffersListViewChildBladeViewModel.prototype.onInputsSet = function (inputs) {
            this.id(inputs.id);
            this.selectedOffer(inputs.selectedOffer);
            this.name(inputs.selectedOffer.Name);
            this.licenseQuantityTxField.value(1);
            this.descriptionText(inputs.selectedOffer.Description);
            this.descriptionUrl(inputs.selectedOffer.Links.LearnMore.Uri);
            this.title("Purchase Offer");
            this.subscriptionId(inputs.subscriptionId);
            return Q();
        };
        return CloudServiceOffersListViewChildBladeViewModel;
    }(MsPortalFx.ViewModels.Blade));
    exports.CloudServiceOffersListViewChildBladeViewModel = CloudServiceOffersListViewChildBladeViewModel;
});
