define(["require", "exports", "../../Shared/Helpers"], function (require, exports, Helpers) {
    "use strict";
    var FxGrid = MsPortalFx.ViewModels.Controls.Lists.Grid;
    var FxGridExtensions = FxGrid.Extensions;
    var CloudServiceUsersGridPartViewModel = (function () {
        function CloudServiceUsersGridPartViewModel(container, initialState, dataContext) {
            this._container = container;
            this._dataContext = dataContext;
            var gridExtensions = FxGridExtensions.SelectableRow;
            var gridExtensionOptions = {
                selectableRow: {
                    selectionMode: 1
                }
            };
            this.cloudServiceUsersGrid = new FxGrid.ViewModel(container, ko.observableArray([]), gridExtensions, gridExtensionOptions);
            var basicColumns = [
                {
                    itemKey: "UserId",
                    name: ko.observable("User Id"),
                },
                {
                    itemKey: "DisplayName",
                    name: ko.observable("Name"),
                    activatable: ko.observable(true),
                    format: FxGrid.Format.HtmlBindings,
                    formatOptions: {
                        htmlBindingsTemplate: Helpers.getGridNameActivatableTemplate(),
                        htmlBindingsType: FxGrid.HtmlBindingsType.Default
                    }
                },
                {
                    itemKey: "UserPrincipalName",
                    name: ko.observable("User Principal Name"),
                },
                {
                    itemKey: "FirstName",
                    name: ko.observable("First Name"),
                },
                {
                    itemKey: "LastName",
                    name: ko.observable("Last Name"),
                },
            ];
            this.cloudServiceUsersGrid.columns = ko.observableArray(basicColumns);
            this.cloudServiceUsersGrid.showHeader = true;
            this.cloudServiceUsersGrid.summary = ko.observable("Summary");
            this.cloudServiceUsersGrid.noRowsMessage("No items found");
        }
        CloudServiceUsersGridPartViewModel.prototype.onInputsSet = function (inputs) {
            this._container.partTitle("User Accounts that you own");
            this.cloudServiceUsersGrid.items([{
                    UserId: ko.observable('dea06bcb-4d9f-4eee-80ea-87e53cad6b2b'),
                    DisplayName: ko.observable('Cloud Assert'),
                    UserPrincipalName: ko.observable('admin@jagancloud.onmicrosoft.com	'),
                    FirstName: ko.observable('Jagan'),
                    LastName: ko.observable('Kris'),
                }]);
            return Q();
        };
        return CloudServiceUsersGridPartViewModel;
    }());
    exports.CloudServiceUsersGridPartViewModel = CloudServiceUsersGridPartViewModel;
});
