define(["require", "exports"], function (require, exports) {
    "use strict";
    var FxForms = MsPortalFx.ViewModels.Forms;
    var FxDropDown = MsPortalFx.ViewModels.Obsolete.Forms.DropDown;
    "use strict";
    var CustomParameterHelpers = (function () {
        function CustomParameterHelpers() {
        }
        CustomParameterHelpers.getFormField = function (param, container) {
            var field;
            switch (param.Type) {
                case "String":
                case "StringArray":
                case "Number":
                    field = CustomParameterHelpers.getTextField(param, container);
                    break;
                case "SecureString":
                    field = CustomParameterHelpers.getPasswordField(param, container);
                    break;
                case "Boolean":
                    field = CustomParameterHelpers.getCheckboxField(param, container);
                    break;
                case "Option":
                    field = CustomParameterHelpers.getDropDownField(param, container);
                    break;
                case "Network":
                    field = CustomParameterHelpers.getTextField(param, container);
                    break;
                default:
                    field = CustomParameterHelpers.getTextField(param, container);
                    break;
            }
            return field;
        };
        CustomParameterHelpers.getTextField = function (param, container) {
            var options = {
                label: ko.observable(param.Description),
                defaultValue: ko.observable(param.DefaultValue),
                emptyValueText: ko.observable("Enter " + param.Label)
            };
            return new FxForms.TextBox.ViewModel(container, options);
        };
        CustomParameterHelpers.getPasswordField = function (param, container) {
            var options = {
                label: ko.observable(param.Description),
                emptyValueText: ko.observable("Enter " + param.Label)
            };
            return new FxForms.PasswordBox.ViewModel(container, options);
        };
        CustomParameterHelpers.getCheckboxField = function (param, container) {
            var options = {
                label: ko.observable(param.Description),
                defaultValue: ko.observable((param.DefaultValue == 'true' || param.DefaultValue == 'True'))
            };
            return new FxForms.CheckBox.ViewModel(container, options);
        };
        CustomParameterHelpers.getDropDownField = function (param, container) {
            var dropdownOptionsArray = [];
            for (var _i = 0, _a = param.OptionValues; _i < _a.length; _i++) {
                var option = _a[_i];
                dropdownOptionsArray.push({
                    text: ko.observable(option.Value),
                    value: option.Key
                });
            }
            var dropDownFieldOptions = {
                label: ko.observable(param.Description),
                options: ko.observableArray(dropdownOptionsArray),
                defaultValue: ko.observable(param.DefaultValue)
            };
            return new FxDropDown.ViewModel(container, dropDownFieldOptions);
        };
        return CustomParameterHelpers;
    }());
    exports.CustomParameterHelpers = CustomParameterHelpers;
});
