define(["require", "exports"], function (require, exports) {
    "use strict";
    var DataModels = BillingExtension.DataModels;
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var billingRpApiVersion = fxEnv.billingRpApiVersion;
    "use strict";
    var LicenseManager = (function () {
        function LicenseManager() {
            this.enabledFeaturesEntityUriFormat = ArmHelpers.getArmUriFormatter("/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/license/tenantLicense", billingRpApiVersion);
            this.enabledFeaturesEntity = new MsPortalFx.Data.EntityCache({
                entityTypeName: DataModels.ProductFeaturesDataModelType,
                sourceUri: this.enabledFeaturesEntityUriFormat,
                supplyData: ArmHelpers.getArmDataSupplier(),
                processServerResponse: function (data) { return { data: data }; },
                poll: false
            });
        }
        return LicenseManager;
    }());
    exports.LicenseManager = LicenseManager;
});
