define(["require", "exports", "../Helpers"], function (require, exports, Helpers) {
    "use strict";
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = fxEnv.billingRpApiVersion;
    "use strict";
    var UsageAndQuotaDataManager = (function () {
        function UsageAndQuotaDataManager() {
            this.Urls = {
                getAzSQuotaFilters: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/tenantUsageAndQuota/getTenantFiltersForAzureStackQuota",
                getAzSSnapInView: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/tenantUsageAndQuota/getAzureStackQuotaSnapInForSubscriptions",
                getAzSTrendView: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/tenantUsageAndQuota/getAzureStackQuotaTrendForSubscriptions",
                downloadAzSQuotaSummary: "/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/tenantUsageAndQuota/downloadAzureStackQuotaSummary"
            };
            this.downloadAzSQuotaSummaryUri = ArmHelpers.getArmUriFormatter(this.Urls.downloadAzSQuotaSummary, rpApiVersion);
        }
        UsageAndQuotaDataManager.prototype.getAzSQuotaFilters = function (subscriptionId, subscriptionIds) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSQuotaFilters, false)(argsToUri);
            var postData = ko.toJSON(subscriptionIds);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.getAzSSnapInView = function (subscriptionId, azureStackQuotaOverviewIn) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSSnapInView, false)(argsToUri);
            var postData = ko.toJSON(azureStackQuotaOverviewIn);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.downloadAzSQuotaSummary = function (subscriptionId, azureStackQuotaOverviewIn) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.downloadAzSQuotaSummary, false)(argsToUri);
            var postData = ko.toJSON(azureStackQuotaOverviewIn);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        UsageAndQuotaDataManager.prototype.getAzsTrendView = function (subscriptionId, azureStackQuotaOverviewIn) {
            var argsToUri = {
                subscriptionId: subscriptionId,
                location: "local"
            };
            var uriSegment = MsPortalFx.Data.uriFormatter(this.Urls.getAzSTrendView, false)(argsToUri);
            var postData = ko.toJSON(azureStackQuotaOverviewIn);
            var promise = Helpers.callArm(uriSegment, "POST", rpApiVersion, postData);
            return promise;
        };
        return UsageAndQuotaDataManager;
    }());
    exports.UsageAndQuotaDataManager = UsageAndQuotaDataManager;
});
