define(["require", "exports"], function (require, exports) {
    "use strict";
    var DataModels = BillingExtension.DataModels;
    var ArmHelpers = Common.Helpers;
    var fxEnv = window.fx.environment;
    var rpApiVersion = fxEnv.billingRpApiVersion;
    "use strict";
    var UserCreditsDataManager = (function () {
        function UserCreditsDataManager() {
            this.listUserCreditsQueryUriFormat = ArmHelpers.getArmUriFormatter("/subscriptions/{subscriptionId}/providers/CloudAssert.Billing/locations/{location}/userCredits", rpApiVersion);
            this.listUserCreditsQuery = new MsPortalFx.Data.QueryCache({
                entityTypeName: DataModels.UserCreditModelType,
                sourceUri: this.listUserCreditsQueryUriFormat,
                supplyData: ArmHelpers.getArmDataSupplier(),
                processServerResponse: function (data) { return { data: data }; },
                poll: false
            });
        }
        return UserCreditsDataManager;
    }());
    exports.UserCreditsDataManager = UserCreditsDataManager;
});
