define(["require", "exports", "../Blades/DocStyles.css", "../Blades/TenantBillingStyles.css", "../../Billing/ViewModels/Overview/BillingOverviewSettingsListBladeViewModel", "../../Billing/ViewModels/Overview/BillingOverviewSettingsListPartViewModel"], function (require, exports, BladesDocStylescss, BladesTenantBillingStylescss) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.blade = {
            "name": "BillingOverviewSettingsListBlade",
            "inputs": [
                "id"
            ],
            "viewModelName": "Billing$BillingOverviewSettingsListBladeViewModel",
            "lenses": [
                {
                    "name": "SettingListLens",
                    "partInstances": [
                        {
                            "name": "SettingListPart",
                            "inline": {
                                "styleSheets": [
                                    {
                                        "file": "Blades/TenantBillingStyles.css",
                                        "content": BladesTenantBillingStylescss
                                    },
                                    {
                                        "file": "Blades/DocStyles.css",
                                        "content": BladesDocStylescss
                                    }
                                ],
                                "viewModel": "Billing$BillingOverviewSettingsListPartViewModel",
                                "partKind": 0,
                                "inputs": [
                                    "id"
                                ],
                                "bindings": [
                                    {
                                        "property": "id",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "id"
                                            }
                                        ]
                                    }
                                ],
                                "details": [
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.settingList.selectableData"
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ],
                                "initialSize": 8,
                                "supportedSizes": [
                                    8
                                ],
                                "viewStateProperties": [
                                    "content.settingList.selectableData.activatedItems",
                                    "content.settingList.selectableData.selectedItems"
                                ],
                                "htmlTemplateInline": {
                                    "file": "Client\\Billing\\Billing.UserOverview.pdl",
                                    "content": "<div data-bind=\"pcGrid: settingList\"></div>"
                                }
                            }
                        }
                    ]
                }
            ],
            "viewModelInputs": [
                {
                    "property": "id",
                    "valuesFrom": [
                        {
                            "referenceType": 1,
                            "property": "id"
                        }
                    ]
                }
            ],
            "width": 0,
            "locked": true,
            "style": 11,
            "attributes": 0
        };
    })(Main || (Main = {}));
    return Main;
});
