define(["require", "exports", "../Blades/DocStyles.css", "../Blades/TenantBillingStyles.css", "../Blades/TenantInvoiceStyles.css", "../../Billing/ViewModels/InvoiceDetailBladeViewModel"], function (require, exports, BladesDocStylescss, BladesTenantBillingStylescss, BladesTenantInvoiceStylescss) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.blade = {
            "name": "InvoiceDetailBlade",
            "inputs": [
                "subscriptionId",
                "invoiceId"
            ],
            "templateKeyInputs": [
                "subscriptionId",
                "invoiceId"
            ],
            "viewModelName": "Billing$InvoiceDetailBladeViewModel",
            "lenses": [],
            "width": 2,
            "pinnable": false,
            "toolbar": {
                "source": {
                    "valuesFrom": [
                        {
                            "referenceType": 0,
                            "property": "content.commandBar"
                        }
                    ]
                }
            },
            "templateBlade": {
                "htmlTemplate": null,
                "partSize": 0,
                "htmlTemplateInline": {
                    "file": "InvoiceDetailBlade.html",
                    "content": "<div data-bind=\"with: invoiceData\" class=\"ext-invoice-view\"> <div class=\"ext-invoice-summary-div\"> <h1 data-bind=\"text: HeaderContent\" align=\"center\"></h1> <div class=\"ext-invoice-summary-left\"> <div data-bind=\"image: Logo1Image\" class=\"ext-invoice-logo\" style=\"width:150px;height:82px;\" alt=\"Invoice Logo\"></div> <table> <tbody> <tr> <td><label><span>Invoice #:</span></label></td> <td> <span data-bind=\"text: Id\"></span> </td> </tr> <tr> <td><label><span>User:</span></label></td> <td> <span data-bind=\"text: UserId\"></span> </td> </tr> <tr> <td><label><span>Subscription:</span></label></td> <td> <span data-bind=\"text: SubscriptionId\"></span> </td> </tr> <tr> <td><label><span>Period:</span></label></td> <td> <span data-bind=\"text: BillingPeriodString\"></span> </td> </tr> <tr> <td><label><span>Due Date:</span></label></td> <td> <span data-bind=\"text: InvoiceDueDateString\"></span> </td> </tr> <tr> <td><label>Amount:</label></td> <td> <span data-bind=\"text: FinalBillableAmountString\" style=\"border: none; color: red\"></span> </td> </tr> </tbody> </table> </div> <!-- left --> </div> <!-- invoice-summary-div --> <!--<div class=\"invoice-notes\">\r\n        <h2>@pdfSettings.NotesDisplayName:</h2>\r\n        <p>@pdfSettings.Notes</p>\r\n    </div>--> <div class=\"ext-invoice-line-items-input-div\"> <h1>Items</h1> <div class=\"ext-invoice-line-items-div\"> <table class=\"ext-invoice-line-items-table\"> <thead> <tr> <th>Description</th> <!--<th>Period</th>--> <th>Unit Price</th> <th>Quantity</th> <th>Amount</th> </tr> </thead> <tbody data-bind=\"foreach: { data: LineItems, as: 'lineItem' }\"> <tr> <td data-bind=\"text: lineItem.Description\"></td> <!--<td data-bind=\"text: lineItem.Period\"></td>--> <td data-bind=\"text: lineItem.UnitPrice\"></td> <td data-bind=\"text: lineItem.Quantity\"></td> <td data-bind=\"text: lineItem.Amount\"></td> </tr> </tbody> <tbody> <tr> <td style=\"text-align: right;\" colspan=\"3\"><label><b>Amount</b></label></td> <td data-bind=\"text: FinalBillableAmountString\"></td> </tr> </tbody> </table> </div> <h1 data-bind=\"text: FooterContent\"></h1> </div> </div>"
                },
                "styleSheets": [
                    {
                        "file": "Blades/TenantBillingStyles.css",
                        "content": BladesTenantBillingStylescss
                    },
                    {
                        "file": "Blades/DocStyles.css",
                        "content": BladesDocStylescss
                    },
                    {
                        "file": "Blades/TenantInvoiceStyles.css",
                        "content": BladesTenantInvoiceStylescss
                    }
                ]
            },
            "attributes": 0
        };
    })(Main || (Main = {}));
    return Main;
});
