define(["require", "exports", "ClientResources", "../../Billing/ViewModels/SubscriptionOverview/SubscriptionOverviewBladeViewModel", "../../Billing/ViewModels/SubscriptionOverview/SubscriptionOverviewResourceSummaryViewModel"], function (require, exports, ClientResources) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.blade = {
            "name": "SubscriptionOverviewBlade",
            "inputs": [
                "subscriptionId",
                "billingPeriod"
            ],
            "templateKeyInputs": [
                "subscriptionId"
            ],
            "viewModelName": "Billing$SubscriptionOverviewBladeViewModel",
            "lenses": [
                {
                    "title": ClientResources.Billing.CurrentCostBreakDown.title,
                    "name": "MostRecentBillSplitLens",
                    "partInstances": [
                        {
                            "name": "CurrentCostBreakdownDonutPart",
                            "reference": {
                                "partTypeName": "CostBreakdownDonutPart",
                                "bindings": [
                                    {
                                        "property": "subscriptionId",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "subscriptionId"
                                            }
                                        ]
                                    },
                                    {
                                        "property": "billingPeriod",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "billingPeriod"
                                            }
                                        ]
                                    },
                                    {
                                        "property": "isInvoice",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 5,
                                                "property": "constant_false",
                                                "constantValue": "false"
                                            }
                                        ]
                                    }
                                ],
                                "initialSize": 5
                            }
                        }
                    ]
                },
                {
                    "isSummary": true,
                    "name": "SubscriptionOverviewResourceSummary",
                    "partInstances": [
                        {
                            "name": "ResourceSummaryPart",
                            "inline": {
                                "styleSheets": [],
                                "viewModel": "Billing$SubscriptionOverviewResourceSummaryViewModel",
                                "partKind": 30,
                                "inputs": [
                                    "resourceId",
                                    "billingPeriod"
                                ],
                                "bindings": [
                                    {
                                        "property": "resourceId",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 3,
                                                "property": "content.subscriptionId"
                                            }
                                        ]
                                    },
                                    {
                                        "property": "billingPeriod",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "billingPeriod"
                                            }
                                        ]
                                    }
                                ],
                                "details": [
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.selection"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.asyncSelection"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.tagsSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.accessSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.settingsSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.quickStartSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.keysSelectable"
                                                    }
                                                ]
                                            }
                                        ]
                                    },
                                    {
                                        "invocationInputArguments": [
                                            {
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 0,
                                                        "property": "content.moveResourceSelection"
                                                    }
                                                ]
                                            }
                                        ],
                                        "outputArguments": [
                                            {
                                                "property": "actionBarOutput",
                                                "valuesFrom": [
                                                    {
                                                        "referenceType": 1,
                                                        "property": "actionBarOutput"
                                                    }
                                                ]
                                            }
                                        ]
                                    }
                                ],
                                "initialSize": 4,
                                "partState": {
                                    "inputIdentityProperties": [
                                        "content.collapsed"
                                    ]
                                }
                            }
                        }
                    ]
                }
            ],
            "viewModelInputs": [
                {
                    "property": "subscriptionId",
                    "valuesFrom": [
                        {
                            "referenceType": 1,
                            "property": "subscriptionId"
                        }
                    ]
                }
            ],
            "width": 1,
            "locked": false,
            "attributes": 0
        };
    })(Main || (Main = {}));
    return Main;
});
