define(["require", "exports", "ClientResources"], function (require, exports, ClientResources) {
    "use strict";
    var ExtensionDefinition;
    (function (ExtensionDefinition) {
        var Internal;
        (function (Internal) {
            var untypedDefinition = {
                "commandsCatalog": [],
                "name": "CloudAssertBillingTenantExtension",
                "version": "1.0",
                "hash": "47DEQpj8HBSa+/TImW+5JCeuQeRkm5NMpJWZG3hSuFU=",
                "schemaVersion": "1.0.0.2",
                "sdkVersion": "5.0.302.958 (production_sdk#01c1d67710.180103-1639)",
                "commandGroups": [
                    {
                        "name": "SubscriptionGridCommands",
                        "commands": [
                            {
                                "name": "DownloadSubscriptionUsageCommand",
                                "text": ClientResources.Commands.downloadUsage,
                                "viewModel": "Billing$DownloadUsageCommandViewModel",
                                "commandKind": 3,
                                "bindings": [
                                    {
                                        "property": "subscriptionId",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "SubscriptionId"
                                            }
                                        ]
                                    },
                                    {
                                        "property": "billingPeriod",
                                        "valuesFrom": [
                                            {
                                                "referenceType": 1,
                                                "property": "BillingPeriod"
                                            }
                                        ]
                                    }
                                ]
                            }
                        ]
                    }
                ],
                "htmlTemplates": {}
            };
            Internal.definition = untypedDefinition;
        })(Internal || (Internal = {}));
        ExtensionDefinition.definitionName = "CloudAssertBillingTenantExtension";
        function getDefinition() {
            if (Internal.definition) {
                var def = Internal.definition;
                Internal.definition = null;
                return def;
            }
            throw new Error("Extension definition is no longer available.");
        }
        ExtensionDefinition.getDefinition = getDefinition;
        var External;
        (function (External) {
            var HubsExtension;
            (function (HubsExtension) {
                HubsExtension.name = "HubsExtension";
                var Blades;
                (function (Blades) {
                    var UnauthorizedAssetBlade;
                    (function (UnauthorizedAssetBlade) {
                        UnauthorizedAssetBlade.name = "UnauthorizedAssetBlade";
                    })(UnauthorizedAssetBlade = Blades.UnauthorizedAssetBlade || (Blades.UnauthorizedAssetBlade = {}));
                    var NotFoundAssetBlade;
                    (function (NotFoundAssetBlade) {
                        NotFoundAssetBlade.name = "NotFoundAssetBlade";
                    })(NotFoundAssetBlade = Blades.NotFoundAssetBlade || (Blades.NotFoundAssetBlade = {}));
                    var UnavailableAssetBlade;
                    (function (UnavailableAssetBlade) {
                        UnavailableAssetBlade.name = "UnavailableAssetBlade";
                    })(UnavailableAssetBlade = Blades.UnavailableAssetBlade || (Blades.UnavailableAssetBlade = {}));
                    var BrowseResourceBlade;
                    (function (BrowseResourceBlade) {
                        BrowseResourceBlade.name = "BrowseResourceBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resourceType = "resourceType";
                        })(Inputs = BrowseResourceBlade.Inputs || (BrowseResourceBlade.Inputs = {}));
                    })(BrowseResourceBlade = Blades.BrowseResourceBlade || (Blades.BrowseResourceBlade = {}));
                    var BrowseAllResourcesBlade;
                    (function (BrowseAllResourcesBlade) {
                        BrowseAllResourcesBlade.name = "BrowseAllResourcesBlade";
                    })(BrowseAllResourcesBlade = Blades.BrowseAllResourcesBlade || (Blades.BrowseAllResourcesBlade = {}));
                    var BrowseAllFilteredResourcesBlade;
                    (function (BrowseAllFilteredResourcesBlade) {
                        BrowseAllFilteredResourcesBlade.name = "BrowseAllFilteredResourcesBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.filter = "filter";
                        })(Inputs = BrowseAllFilteredResourcesBlade.Inputs || (BrowseAllFilteredResourcesBlade.Inputs = {}));
                    })(BrowseAllFilteredResourcesBlade = Blades.BrowseAllFilteredResourcesBlade || (Blades.BrowseAllFilteredResourcesBlade = {}));
                    var BrowseResourceGroupBlade;
                    (function (BrowseResourceGroupBlade) {
                        BrowseResourceGroupBlade.name = "BrowseResourceGroupBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.resourceType = "resourceType";
                        })(Inputs = BrowseResourceGroupBlade.Inputs || (BrowseResourceGroupBlade.Inputs = {}));
                    })(BrowseResourceGroupBlade = Blades.BrowseResourceGroupBlade || (Blades.BrowseResourceGroupBlade = {}));
                    var MapResourceGroupBlade;
                    (function (MapResourceGroupBlade) {
                        MapResourceGroupBlade.name = "MapResourceGroupBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = MapResourceGroupBlade.Inputs || (MapResourceGroupBlade.Inputs = {}));
                    })(MapResourceGroupBlade = Blades.MapResourceGroupBlade || (Blades.MapResourceGroupBlade = {}));
                    var ResourceGroupPickerV3Blade;
                    (function (ResourceGroupPickerV3Blade) {
                        ResourceGroupPickerV3Blade.name = "ResourceGroupPickerV3Blade";
                    })(ResourceGroupPickerV3Blade = Blades.ResourceGroupPickerV3Blade || (Blades.ResourceGroupPickerV3Blade = {}));
                    var DeployFromTemplateBlade;
                    (function (DeployFromTemplateBlade) {
                        DeployFromTemplateBlade.name = "DeployFromTemplateBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.internal_bladeCallerParams = "internal_bladeCallerParams";
                        })(Inputs = DeployFromTemplateBlade.Inputs || (DeployFromTemplateBlade.Inputs = {}));
                    })(DeployFromTemplateBlade = Blades.DeployFromTemplateBlade || (Blades.DeployFromTemplateBlade = {}));
                    var ParametersEditorBlade;
                    (function (ParametersEditorBlade) {
                        ParametersEditorBlade.name = "ParametersEditorBlade";
                    })(ParametersEditorBlade = Blades.ParametersEditorBlade || (Blades.ParametersEditorBlade = {}));
                    var TemplateEditorBlade;
                    (function (TemplateEditorBlade) {
                        TemplateEditorBlade.name = "TemplateEditorBlade";
                    })(TemplateEditorBlade = Blades.TemplateEditorBlade || (Blades.TemplateEditorBlade = {}));
                    var LocationPickerV3Blade;
                    (function (LocationPickerV3Blade) {
                        LocationPickerV3Blade.name = "LocationPickerV3Blade";
                    })(LocationPickerV3Blade = Blades.LocationPickerV3Blade || (Blades.LocationPickerV3Blade = {}));
                    var DeploymentDetailsBlade;
                    (function (DeploymentDetailsBlade) {
                        DeploymentDetailsBlade.name = "DeploymentDetailsBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = DeploymentDetailsBlade.Inputs || (DeploymentDetailsBlade.Inputs = {}));
                    })(DeploymentDetailsBlade = Blades.DeploymentDetailsBlade || (Blades.DeploymentDetailsBlade = {}));
                    var ResourceGroupMapBlade;
                    (function (ResourceGroupMapBlade) {
                        ResourceGroupMapBlade.name = "ResourceGroupMapBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = ResourceGroupMapBlade.Inputs || (ResourceGroupMapBlade.Inputs = {}));
                    })(ResourceGroupMapBlade = Blades.ResourceGroupMapBlade || (Blades.ResourceGroupMapBlade = {}));
                    var ResourceMenuBlade;
                    (function (ResourceMenuBlade) {
                        ResourceMenuBlade.name = "ResourceMenuBlade";
                        var Inputs;
                        (function (Inputs) {
                            Inputs.id = "id";
                        })(Inputs = ResourceMenuBlade.Inputs || (ResourceMenuBlade.Inputs = {}));
                    })(ResourceMenuBlade = Blades.ResourceMenuBlade || (Blades.ResourceMenuBlade = {}));
                    var ServicesHealthBlade;
                    (function (ServicesHealthBlade) {
                        ServicesHealthBlade.name = "ServicesHealthBlade";
                    })(ServicesHealthBlade = Blades.ServicesHealthBlade || (Blades.ServicesHealthBlade = {}));
                    var SettingsBlade;
                    (function (SettingsBlade) {
                        SettingsBlade.name = "SettingsBlade";
                    })(SettingsBlade = Blades.SettingsBlade || (Blades.SettingsBlade = {}));
                    var SubscriptionPickerV3Blade;
                    (function (SubscriptionPickerV3Blade) {
                        SubscriptionPickerV3Blade.name = "SubscriptionPickerV3Blade";
                    })(SubscriptionPickerV3Blade = Blades.SubscriptionPickerV3Blade || (Blades.SubscriptionPickerV3Blade = {}));
                })(Blades = HubsExtension.Blades || (HubsExtension.Blades = {}));
            })(HubsExtension = External.HubsExtension || (External.HubsExtension = {}));
        })(External = ExtensionDefinition.External || (ExtensionDefinition.External = {}));
        var AssetTypes;
        (function (AssetTypes) {
            var Billing;
            (function (Billing) {
                Billing.name = "Billing";
            })(Billing = AssetTypes.Billing || (AssetTypes.Billing = {}));
            var CloudServices;
            (function (CloudServices) {
                CloudServices.name = "CloudServices";
            })(CloudServices = AssetTypes.CloudServices || (AssetTypes.CloudServices = {}));
        })(AssetTypes = ExtensionDefinition.AssetTypes || (ExtensionDefinition.AssetTypes = {}));
        var AssetTypeNames;
        (function (AssetTypeNames) {
            AssetTypeNames.billing = AssetTypes.Billing.name;
            AssetTypeNames.cloudServices = AssetTypes.CloudServices.name;
        })(AssetTypeNames = ExtensionDefinition.AssetTypeNames || (ExtensionDefinition.AssetTypeNames = {}));
        var BladeNames;
        (function (BladeNames) {
            BladeNames.billingOverviewBlade = "BillingOverviewBlade";
            BladeNames.billingOverviewSettingsListBlade = "BillingOverviewSettingsListBlade";
            BladeNames.billingOverviewPropertiesBlade = "BillingOverviewPropertiesBlade";
            BladeNames.billingMenuBlade = "BillingMenuBlade";
            BladeNames.invoicesCollectionBlade = "InvoicesCollectionBlade";
            BladeNames.invoiceDetailBlade = "InvoiceDetailBlade";
            BladeNames.subscriptionOverviewBlade = "SubscriptionOverviewBlade";
            BladeNames.usageHistoryByResourcesGridBlade = "UsageHistoryByResourcesGridBlade";
            BladeNames.usageHistoryBlade = "UsageHistoryBlade";
            BladeNames.userBasicProfileBlade = "UserBasicProfileBlade";
            BladeNames.contactInfoBlade = "ContactInfoBlade";
            BladeNames.billingAddressBlade = "BillingAddressBlade";
            BladeNames.paymentMethodsBlade = "PaymentMethodsBlade";
            BladeNames.cloudServicesMenuBlade = "CloudServicesMenuBlade";
            BladeNames.cloudServicesOverviewBlade = "CloudServicesOverviewBlade";
            BladeNames.cloudServiceSubscriptionsBlade = "CloudServiceSubscriptionsBlade";
            BladeNames.purchaseCloudServiceBlade = "PurchaseCloudServiceBlade";
            BladeNames.cloudServiceSubscriptionDetailsBlade = "CloudServiceSubscriptionDetailsBlade";
            BladeNames.cloudServiceUsersBlade = "CloudServiceUsersBlade";
            BladeNames.addCloudServiceCustomerFormBlade = "AddCloudServiceCustomerFormBlade";
            BladeNames.availableCloudServiceLicensesBlade = "AvailableCloudServiceLicensesBlade";
            BladeNames.assignCloudServiceLicensesBlade = "AssignCloudServiceLicensesBlade";
            BladeNames.notificationMessagesBlade = "NotificationMessagesBlade";
            BladeNames.notificationRulesBlade = "NotificationRulesBlade";
            BladeNames.notificationAddEditBlade = "NotificationAddEditBlade";
            BladeNames.notificationMessageDetailsBlade = "NotificationMessageDetailsBlade";
            BladeNames.cloudServiceOffersList = "CloudServiceOffersList";
            BladeNames.cloudServiceOffersListViewChildBlade = "CloudServiceOffersListViewChildBlade";
            BladeNames.cloudServiceCustomerProfilesBlade = "CloudServiceCustomerProfilesBlade";
            BladeNames.addCloudServiceCustomerProfileBlade = "AddCloudServiceCustomerProfileBlade";
            BladeNames.onboardExistingCloudServiceCustomerProfileBlade = "OnboardExistingCloudServiceCustomerProfileBlade";
            BladeNames.usageAndQuotaStatusBlade = "UsageAndQuotaStatusBlade";
            BladeNames.usageAndQuotaSnapInBlade = "UsageAndQuotaSnapInBlade";
            BladeNames.usageAndQuotaTrendBlade = "UsageAndQuotaTrendBlade";
        })(BladeNames = ExtensionDefinition.BladeNames || (ExtensionDefinition.BladeNames = {}));
        var CommandGroupNames;
        (function (CommandGroupNames) {
            CommandGroupNames.subscriptionGridCommands = "SubscriptionGridCommands";
        })(CommandGroupNames = ExtensionDefinition.CommandGroupNames || (ExtensionDefinition.CommandGroupNames = {}));
    })(ExtensionDefinition || (ExtensionDefinition = {}));
    return ExtensionDefinition;
});
