define(["require", "exports", "../Blades/DocStyles.css", "../Blades/TenantBillingStyles.css", "../../Billing/ViewModels/SubscriptionsOverviewGridPartViewModel"], function (require, exports, BladesDocStylescss, BladesTenantBillingStylescss) {
    "use strict";
    var Main;
    (function (Main) {
        "use strict";
        Main.part = {
            "styleSheets": [
                {
                    "file": "Blades/TenantBillingStyles.css",
                    "content": BladesTenantBillingStylescss
                },
                {
                    "file": "Blades/DocStyles.css",
                    "content": BladesDocStylescss
                }
            ],
            "name": "SubscriptionsOverviewGridPart",
            "viewModel": "Billing$SubscriptionsOverviewGridPartViewModel",
            "partKind": 0,
            "canUseOldInputVersions": false,
            "inputs": [
                "subscriptionsCategory",
                "monitorBillingPeriodDropDown"
            ],
            "bindings": [
                {
                    "property": "subscriptionsCategory",
                    "valuesFrom": [
                        {
                            "referenceType": 1,
                            "property": "subscriptionsCategory"
                        }
                    ]
                },
                {
                    "property": "monitorBillingPeriodDropDown",
                    "valuesFrom": [
                        {
                            "referenceType": 1,
                            "property": "monitorBillingPeriodDropDown"
                        }
                    ]
                }
            ],
            "details": [
                {
                    "selectablePath": "content.subscriptionsGrid.selectableData",
                    "blade": "SubscriptionOverviewBlade",
                    "selectableBindings": [
                        {
                            "property": "subscriptionId",
                            "valuesFrom": [
                                {
                                    "referenceType": 6,
                                    "property": "SubscriptionId"
                                }
                            ]
                        }
                    ],
                    "additionalInputArguments": [
                        {
                            "property": "billingPeriod",
                            "valuesFrom": [
                                {
                                    "referenceType": 0,
                                    "property": "content.billingPeriod"
                                }
                            ]
                        }
                    ]
                }
            ],
            "htmlTemplateInline": {
                "file": "SubscriptionsOverviewGridPart.html",
                "content": "<div> <span style=\"font-size: 24px; font-weight: bold\" data-bind='text: subscriptionsGrid.items().length'></span> <span style=\"font-size: 16px; font-weight: bold\"> Subscriptions </span> <span class=\"ext-docs-medium-icon\" style=\"padding-top: 10px;\" data-bind=\"image: billingIcon\"></span> </div> <div data-bind='pcControl: subscriptionsGrid'></div> <br/> <div data-bind=\"visible: isCurrentMonth\"> <span style=\"font-size: 16px; font-weight: bold\"> Remaining User Credits </span> <div data-bind=\"text:remainingCreditsText\"></div> </div> "
            }
        };
    })(Main || (Main = {}));
    return Main;
});
